UNIT jocgi;

{  * **** ** *                  *
   *         JoCGI unit         *
   *  for FreePascal (1.0 min)  *
   *  (almost all i386 targets) *
   *                            *
   *         by IoDream         *
   *      Toulouse/France       *
   * mailto:IoDream@ifrance.com *
   *                  * ** **** *  }

{ * **** ** *
  * Greets fly to:
  *  + Royale, for his help in testing and programming, and some lite routines
  *    there (Write_in_HTML for example) that come from his personal cgi unit;
  *  + Michael Van Canneyt, for the CGI programming introduction in FPC_User
  *    manual, and his uncgi unit that was one of my reference, from where I
  *    got working Dos/Go32v2 and Win32 UpGetEnv functions;
  *  + Everyone who develop and support FreePascal, the compiler that build
  *    our future, and all that comes with it (FCL, units,...).
  *                                       Keep doing such a good work, guys ! }

{ Note: this has been successfully tested on Apache 1.3 web server, using
  Dos/Go32v2 and Win32 targets. It should work under Linux, and under other
  web servers, though it haven't been tested yet.
  Os2 and BEos compatibility should be good, just write a new UpGetEnv, which
  is the only system dependant function, and mail me the fix if it works.     }

{$IFNDEF i386}
  {$IFDEF LINUX} {$STOP This target may not work, cause it has been written for i386 plaltforms} USES linux;
  {$ELSE} {$STOP Sorry this target will not certainly be supported }
{$ENDIF linux} {$ENDIF i386}
{$IFDEF ALPHA} {$STOP This target may not work, cause it has been written for i386 plaltforms} {$ENDIF alpha}
{$IFDEF POWERPC} {$STOP This target may not work, cause it has been written for i386 plaltforms} {$ENDIF powerpc}
{$IFDEF OS2} {$STOP This target isn't supported for now (see note above)} {$ENDIF os2}
{$IFDEF BEOS} {$STOP This target isn't supported for now (see note above)} {$ENDIF beos}
  { Is BEos target name = "BEOS" ? }
{$IFDEF GO32V1} {$STOP This target haven't been tested yet, because it's somehow out of date} {$ENDIF go32v1}

{H+} {Turn on ANSISTRINGS}

{***} INTERFACE {***}

{$IFDEF LINUX} USES linux; {$ENDIF linux}
{$IFDEF WIN32} USES strings; {$ENDIF win32}

{****************************************************************************}

CONST jocgi_version = 'JoCGI 1.0.0 unit';  {26/09/2000, european format}
      {$IFDEF GO32V2} NewLine = #13#10; {$ENDIF go32v2}  { System dependant newline string }
      {$IFDEF WIN32} NewLine = #13#10; {$ENDIF win32}
      {$IFDEF LINUX} NewLine = #10; {$ENDIF linux}
      {$IFDEF GO32V1} NewLine = #13#10; {$ENDIF go32v1}
      {$IFDEF OS2} NewLine = #13#10; {$ENDIF newline}
      {$IFDEF BEOS} NewLine = #13; {$ENDIF beos}
      HtmlChar = ''+''+''+''+''+''+''+''+''+''+'ݟ'
                +''+'<>&'+''+'"';  {Chars to be expanded in Html}
      HtmlCharStr : ARRAY[1..75] OF ANSISTRING =  {Html expansion of the chars above}
      ('&Aacute;', '&Agrave;', '&Acirc;', '&Auml;', '&Atilde','&Aring', 
       '&aacute;', '&agrave;', '&acirc;', '&auml;', '&Atilde','&aring', 
       '&Eacute;', '&Egrave;', '&Ecirc;', '&Euml;',
       '&eacute;', '&egrave;', '&ecirc;', '&euml;',
       '&Iacute;', '&Igrave;', '&Icirc;', '&Iuml;',
       '&iacute;', '&igrave;', '&icirc;', '&iuml;',
       '&Oacute;', '&Ograve;', '&Ocirc;', '&Ouml;', '&Otilde',
       '&oacute;', '&ograve;', '&ocirc;', '&ouml;', '&otilde',
       '&Uacute;', '&Ugrave;', '&Ucirc;', '&Uuml;',
       '&uacute;', '&ugrave;', '&ucirc;', '&uuml;',
       '&Yacute;', '&Yuml;', '&yacute;', '&yuml;', '&Ntilde;', '&ntilde;',
       '&Ccedil;', '&ccedil;', '&AElig;', '&aelig;', '&#156;',
       '&lt;', '&gt;', '&copy;', '&reg;', '&amp;', '&pound;',
       '&micro;', '&sect;', '&curren;', '&iexcl;', '&iquest;', '&szlig;',
       '&Oslash;', '&oslash;', '&cent;', '&quot;', '&eth;', '&times;'       );

TYPE PChainedPairRec = ^ChainedPairRec;
     ChainedPairRec = RECORD  {Name:Value chained pairs}
       Next : PChainedPairRec;
       Name, Value : ANSISTRING;
     END;
     ChainedPair = RECORD  {Chained list type of Name:Value pairs}
       FirstP, LastP : PChainedPairRec;  {Pointers to the first and the last pair record}
       Last : WORD;  {Index number of the last pair. If 0 then no pair}
     END;

CONST LocalEnvStr : ARRAY[1..39] OF ANSISTRING =(
        { Standard HTTP Environment Variables }
          'ALL_HTTP', 'DOCUMENT_ROOT', 'HTTP_ACCEPT', 'HTTP_ACCEPT_CHARSET',
          'HTTP_COOKIE', 'HTTP_ACCEPT_ENCODING', 'HTTP_ACCEPT_LANGUAGE',
          'HTTP_CONNECTION', 'HTTP_FROM', 'HTTP_HOST', 'HTTP_IF_MODIFIED_SINCE',
          'HTTP_REFERER', 'HTTP_USER_AGENT', 'URL',
        { Standard CGI Environment Variables }
          'AUTH_TYPE', 'CONTENT_LENGTH', 'CONTENT_TYPE', 'GATEWAY_INTERFACE', 'PATH_INFO',
          'PATH_TRANSLATED', 'QUERY_STRING', 'REMOTE_ADDR', 'REMOTE_HOST', 'REMOTE_IDENT',
          'REMOTE_PORT', 'REMOTE_USER', 'REQUEST_METHOD', 'REQUEST_URI',
          'SCRIPT_FILENAME','SCRIPT_NAME', 'SERVER_ADMIN', 'SERVER_ADDR', 'SERVER_NAME',
          'SERVER_PORT', 'SERVER_POST_SECURE', 'SERVER_PROTOCOL', 'SERVER_SIGNATURE',
          'SERVER_SOFTWARE', 'UNMAPPED_REMOTE_USER'
          );

VAR LocalEnv_Chain,              {Where environment vars are stored }
    Query_Chain,                 {Where all queries are stored}
    Cookie_Chain : ChainedPair;  {Where all cookies are stored}
    Method : ANSISTRING;  {Shorthand to REQUEST_METHOD: POST or GET or empty}
    QueryString : ANSISTRING;  {All the cgi-form values urlencoded}
    CookieString : ANSISTRING;  {All the cookie values urlencoded}
    NextPCP : PChainedPairRec;  {Used by CPNext}

{****************************************************************************}

{*** MISC ***}

FUNCTION long2ansi(long : LONGINT) : ANSISTRING;
{A shorthand to convert a LONGINT to an ANSISTRING}

FUNCTION ansi2long(ansi : ANSISTRING) : LONGINT;
{A shorthand to convert an ANSISTRING to a LONGINT}

{*** CHAINEDPAIR HANDLING ***}

PROCEDURE CPInit(VAR CP : ChainedPair);
{Initialize a ChainedPair}

PROCEDURE CPDone(VAR CP : ChainedPair);
{Destroy a ChainedPair}

PROCEDURE CPAdd(VAR CP : ChainedPair; N, V : ANSISTRING);
{Add a pair at the end of the ChainedPair}

FUNCTION CPFind(VAR CP : ChainedPair; N : ANSISTRING) : ANSISTRING;
{Find N in all Name of CP and return the corresponding Value, if it exist}

FUNCTION CPNextInit(CP : ChainedPair; Start : WORD) : BOOLEAN;
{Use it before CPNext. Start is the index to start from. Return FALSE if out of order}

FUNCTION CPNext : BOOLEAN;
{Return the next N(ame):V(alue) pair with NextPCP^. If there is no more pair then return false}

{*** CGI OUTPUT ***}

PROCEDURE Open_CGI;
{Open the CGI output}

PROCEDURE Close_CGI;
{Close the CGI output}

PROCEDURE Write_in_HTML(text : ANSISTRING);
{Translate some special chars to HTML}

{*** CGI INPUT ***}

FUNCTION FindQuery(Id : ANSISTRING) : ANSISTRING;
{Find in Query_Chain the query named Id and return it}

PROCEDURE ShowQueries;
{Write all the Queries to HTML}

PROCEDURE ShowCookies;
{Write all the Cookies to HTML}

PROCEDURE ShowEnv;
{Write all the LocalEnv chain to HTML}

{$IFDEF GO32V2}
PROCEDURE ShowAllEnv;
{For DEBUG on GO32V2: Print out all environment variables}
{$ENDIF go32v2}

{***} IMPLEMENTATION {***}

{*** MISC ***}

FUNCTION long2ansi(long : LONGINT) : ANSISTRING;
{A shorthand to convert a LONGINT to an ANSISTRING}
BEGIN
  Str(long, long2ansi);
END {long2ansi};

FUNCTION ansi2long(ansi : ANSISTRING) : LONGINT;
{A shorthand to convert an ANSISTRING to a LONGINT}
BEGIN
  Val(ansi, ansi2long);
END {ansi2long};

{*** CHAINEDPAIR HANDLING ***}

PROCEDURE CPInit(VAR CP : ChainedPair);
{Initialize a ChainedPair}
BEGIN
  CP.FirstP := NIL;
  CP.LastP := NIL;
  CP.Last := 0;
END {CPInit};

PROCEDURE CPDone(VAR CP : ChainedPair);
{Destroy a ChainedPair}
VAR PCP, TempPCP : PChainedPairRec;
BEGIN
  PCP := CP.FirstP;
  WHILE PCP <> NIL DO
    BEGIN
      TempPCP := PCP;
      PCP := PCP^.Next;
      TempPCP^.Name := '';
      TempPCP^.Value := '';
      Dispose(TempPCP);
    END;
  CPInit(CP);
END {CPDone};

PROCEDURE CPAdd(VAR CP : ChainedPair; N, V : ANSISTRING);
{Add a pair at the end of the ChainedPair}
VAR PCP : PChainedPairRec;
BEGIN
  New(PCP);
  WITH PCP^ DO
    BEGIN
      Name := N;
      Value := V;
      Next := NIL;
    END;
  IF CP.Last = 0 THEN
     BEGIN
       CP.LastP := PCP;
       CP.FirstP := PCP;
     END ELSE BEGIN
       CP.LastP^.Next := PCP;
       CP.LastP := PCP;
     END;
  Inc(CP.Last);
END {CPAdd};

FUNCTION CPFind(VAR CP : ChainedPair; N : ANSISTRING) : ANSISTRING;
{Find N in all Name of CP and return the corresponding Value, if it exist}
VAR PCP : PChainedPairRec;
BEGIN
  PCP := CP.FirstP;
  CpFind := '';
  WHILE (PCP <> NIL) AND (CPFind = '') DO
    WITH PCP^ DO
      IF Name = N THEN
         BEGIN CpFind := Value; NextPCP := PCP^.Next; END
         ELSE PCP := Next;
END {CPFind};

FUNCTION CPNextInit(CP : ChainedPair; Start : WORD) : BOOLEAN;
{Use it before CPNext. Start is the index to start from. Return FALSE if out of order}
VAR i : WORD;
BEGIN
{  WriteLn('Here is CPNextInit with Start=', Start);  FOR DEBUG
  IF CP.FirstP = LocalEnv_Chain.FirstP THEN WriteLn('LocalEnv_Chain');
  IF CP.FirstP = Query_Chain.FirstP THEN WriteLn('Query_Chain');
  IF CP.FirstP = Cookie_Chain.FirstP THEN WriteLn('Cookie_Chain');}
  NextPCP := CP.FirstP;
  If Start = 0 THEN Inc(Start);
  CPNextInit := (CP.Last >= Start);
  IF CPNextInit THEN
     FOR i := 2 TO Start DO NextPCP := NextPCP^.Next;
END {CPNextInit};

FUNCTION CPNext : BOOLEAN;
{Return the next N(ame):V(alue) pair with NextPCP^. If there is no more pair then return false}
BEGIN
  NextPCP := NextPCP^.Next;
  CPNext := (NextPCP <> NIL);
END {CPNext};

{*** CGI OUTPUT ***}

PROCEDURE Open_CGI;
{Open the CGI output}
BEGIN
  WriteLn('Content-type: text/html');
  WriteLn;
  WriteLn('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">');
 {Put the following line inside comments if you want but some greets would be appreciated ;) }
  WriteLn('<!-- Generated with the help of ', jocgi_version, ' unit -->');
  WriteLn('<!-- Compiled by Free Pascal Compiler version ', {$I %FPCVERSION%}, ' -->');
  WriteLn('<HTML>');
  WriteLn('<BODY>');
END {Open_CGI};

PROCEDURE Close_CGI;
{Close the CGI output}
BEGIN
  WriteLn('</BODY>');
  WriteLn('</HTML>');
END {Close_CGI};

PROCEDURE Write_in_HTML(text : ANSISTRING);
{Translate some special chars to HTML}
VAR l : LONGINT;
    n : BYTE;
BEGIN
  FOR l := 1 TO Length(text) DO
    BEGIN
      n := Pos(text[l], HtmlChar);
      IF n<>0 THEN Write(HtmlCharStr[n])
         ELSE Write(text[l]);
    END;
END {Write_in_HTML};

{*** CGI INPUT ***}

FUNCTION FindQuery(Id : ANSISTRING) : ANSISTRING;
{Find in Query_Chain the query named Id and return it}
BEGIN FindQuery := CPFind(Query_Chain, Id); END {FindQuery};

PROCEDURE ShowQueries;
{Write all the Queries to HTML}
VAR q : WORD;
BEGIN
  IF Query_Chain.Last > 0 THEN
     BEGIN
       q := 1;
       WriteLn('<BR><B><I>List of all passed queries :</I></B>');
       CPNextInit(Query_Chain, 0);
       REPEAT
         WITH NextPCP^ DO
           BEGIN
             Write('<BR>', q:3, ': ', Name, '=');
             Write_in_HTML(Value+NewLine);
           END;
         Inc(q);
       UNTIL NOT CPNext;
     END ELSE Write('<BR><B><I>No query name=value pair found.</I></B>');
  WriteLn('</BR>');
END;

PROCEDURE ShowCookies;
{Write all the Cookies to HTML}
VAR q : WORD;
BEGIN
  IF Cookie_Chain.Last > 0 THEN
     BEGIN
       q := 1;
       WriteLn('<BR><B><I>List of all passed cookies :</I></B>');
       CPNextInit(Cookie_Chain, 0);
       REPEAT
         WITH NextPCP^ DO
           BEGIN
             Write('<BR>', q:3, ': ', Name, '=');
             Write_in_HTML(Value+NewLine);
           END;
         Inc(q);
       UNTIL NOT CPNext;
     END ELSE Write('<BR><B><I>No cookie name=value pair found.</I></B>');
  WriteLn('</BR>');
END;

PROCEDURE ShowEnv;
{Write all the LocalEnv chain to HTML}
BEGIN
  WriteLn('<BR><B>LocalEnv array:</B>');
  IF CPNextInit(LocalEnv_Chain, 0) THEN
    REPEAT
      WITH NextPCP^ DO WriteLn('<BR>', Name, '=', Value);
    UNTIL NOT CPNext;
  WriteLn('</BR>')
END {ShowEnv};

{*** SYSTEM DEPENDANT STUFF ***}

{$IFDEF WIN32}
VAR EnvP : PCHAR;
    EnvLen : LONGINT;
    IsWin32InitCGI : BOOLEAN;  {True if memory is allocated for EnvP}

FUNCTION GetEnvironmentStrings : PCHAR; EXTERNAL 'kernel32' NAME 'GetEnvironmentStringsA';
FUNCTION FreeEnvironmentStrings(p : PCHAR) : LONGBOOL; EXTERNAL 'kernel32' NAME 'FreeEnvironmentStringsA';

PROCEDURE FInitWin32CGI;
{Free memory from EnvP}
BEGIN
  IF IsWin32InitCGI THEN FreeMem (EnvP, EnvLen);
  IsWin32InitCGI := FALSE;
END {FInitWin32CGI};

PROCEDURE InitWin32CGI;
{Make a local copy of environment in EnvP}
VAR len : LONGINT;
    hp, p : PCHAR;
BEGIN
  p := GetEnvironmentStrings;
  hp := p;
  EnvP := NIL;
  EnvLen := 0;
  WHILE hp[0]<>#0 DO
    BEGIN
      len := strlen(hp);
      hp := hp+len+1;
      EnvLen := Envlen+len+1;
    END;
  GetMem(EnvP, Envlen);
  Move(P^, EnvP^, EnvLen);
  FreeEnvironmentStrings(p);
  IsWin32InitCGI := TRUE;
END {InitWin32CGI};

FUNCTION UpGetEnv(Id : ANSISTRING) : ANSISTRING;
{UpGetEnv that can return environment vars of length>255}
{Return the environment value of the upcased Id}
VAR i,len : LONGINT;
    hp, envvar, uge : PCHAR;
BEGIN
  envvar := PCHAR(Id);
  UpGetEnv :='';
  hp := EnvP;
  WHILE hp[0]<>#0 DO
    BEGIN
      len := StrLen(hp);
      i := LONGINT(StrScan(hp, '='))-LONGINT(hp);
      IF StrLIComp(envvar, hp, i-1)=0 THEN
         BEGIN
           len := len-i;
           GetMem(uge, len);
           Move(hp[I+1], uge^, len+1);
           UpGetEnv := uge;
           FreeMem(uge, len);
           Break;
         END;
      {next string entry}
      hp := hp+len+1;
    END;
END {UpGetEnv};

(*FUNCTION UpGetEnv(Id : ANSISTRING) : ANSISTRING;  THIS IS THE 'OLD' VERSION
{UpGetEnv that can return environment vars of length>255}
{Return the environment value of the upcased Id}
VAR hs : ANSISTRING;
    hp : PCHAR;
    len, i : LONGINT;
BEGIN
  hp := EnvP;
  Id := UpCase(Id);
  UpGetEnv := '';
  len := StrLen(hp);
  WHILE len <> 0 DO
    BEGIN
      hs := hp;
      hs := UpCase(hs);
      i := Pos('=', hs);
      IF Copy(hs, 1, i-1)=Id THEN
         BEGIN
           UpGetEnv := Copy(hs, i+1, len-i);
           Exit;
         END;
      hp := hp+len+1;
      len := StrLen(hp);
    END;
END  {UpGetEnv};*)
{$ENDIF}

{$IFDEF GO32V2}
PROCEDURE ShowAllEnv;
{For DEBUG on GO32V2: Print out all environment variables}
VAR
  hp : PPCHAR;
  hs : ANSISTRING;
BEGIN
  hp := EnvP;
  WHILE Assigned(hp^) DO
   BEGIN
     hs := hp^;
     WriteLn('<BR>', hs);
     INC(hp);
   END;
END {ShowAllEnv};

FUNCTION UpGetEnv(Id : ANSISTRING) : ANSISTRING;
{UpGetEnv that can return environment vars of length>255}
{Return the environment value of the upcased Id}
VAR hp    : PPCHAR;
    hs    : ANSISTRING;
    eqpos : LONGINT;
BEGIN
  Id := UpCase(Id);
  hp := EnvP;
  UpGetEnv := '';
  WHILE Assigned(hp^) DO
    BEGIN
      hs := hp^;
      eqpos := Pos('=', hs);
      IF Copy(hs, 1, eqpos-1) = Id THEN
         BEGIN
           UpGetEnv := Copy(hs, Succ(eqpos), Length(hs)-eqpos);
           EXIT;
         END;
      INC(hp);
    END;
END {UpGetEnv};
{$ENDIF}

{$IFNDEF GO32V2}{$IFNDEF WIN32}
FUNCTION UpGetEnv(Id : ANSISTRING) : ANSISTRING;
{UpGetEnv that can return environment vars of length>255}
BEGIN UpGetEnv := GetEnv(UpCase(Id)) END {UpGetEnv};
{$ENDIF}{$ENDIF}

{*** INIT CGI INPUT ***}
{All the following stuff is only used once at startup}

FUNCTION HexConv(h1, h2 : CHAR) : CHAR;
{Convert from hex h1:h2 to the corresponding}
VAR tHex : BYTE;
BEGIN
  IF h1 <= '9' THEN tHex := Ord(h1)-Ord('0') ELSE tHex := 10+Ord(h1)-Ord('A');
  thex := thex SHL 4;
   IF h2 <= '9' THEN tHex := tHex+Ord(h2)-Ord('0') ELSE tHex := tHex+10+Ord(h2)-Ord('A');
  HexConv := Char(thex);
END {HexConv};

PROCEDURE UnEscape(CP : ChainedPair);
{UnEscape all the valid Value from CP}
VAR l : LONGINT;
    temps : ANSISTRING;
BEGIN
  IF CP.Last > 0 THEN IF CPNextInit(CP, 0) THEN
     REPEAT
       WITH NextPCP^ DO
         BEGIN
           temps := '';
           FOR l := 1 TO Length(Value) DO
               CASE Value[l] OF
                 '+': temps := temps + ' ';
                 '%': {IF (l+2) > Length(Value) THEN} BEGIN temps := temps + HexConv(Value[l+1], Value[l+2]); Inc(l, 2) END;
                 ELSE temps := temps + Value[l];
               END;
           Value := temps;
         END;
     UNTIL NOT CPNext;
END {UnEscape};

PROCEDURE Chop(VAR CP : ChainedPair; s : ANSISTRING; separator : CHAR);
{Cut the string s into pieces to fill CP}
VAR c : CHAR;
    l, lens : LONGINT;
    isName : BOOLEAN;
    N, V : ANSISTRING;
BEGIN
  isName := TRUE;
  lens := Length(s);
  N := '';
  V := '';
  IF (lens <> 0) THEN
     FOR l := 1 TO lens DO
       BEGIN
         c := s[l];
         IF c = '=' THEN isName := FALSE
            ELSE IF c = separator THEN BEGIN
              isName := TRUE;
              CPAdd(CP, N, V);
              N := '';
              V := '';
            END ELSE IF isName THEN N := N + c
            ELSE V := V + c;
       END;
  IF (V <> '') OR (N <> '') THEN CPAdd(CP, N, V);
END {Chop};

PROCEDURE GetData_Post;
{Get the data from the cgi 'post' and fill QueryString with it}
VAR inputlen, i : WORD;
    c : CHAR;
BEGIN
  inputlen := ansi2long(CPFind(LocalEnv_Chain, 'CONTENT_LENGTH'));
  IF UpCase(CPFind(LocalEnv_Chain, 'CONTENT_TYPE'))='APPLICATION/X-WWW-FORM-URLENCODED' THEN
    FOR i := 1 TO inputlen DO
      BEGIN
        Read(c);
        QueryString := QueryString + c;
      END;
END {GetData_Post};

PROCEDURE GetData_Get;
{Get the data from the cgi 'get' and fill QueryString with it}
BEGIN
  QueryString := CPFind(LocalEnv_Chain, 'QUERY_STRING');
END {GetData_Get};

PROCEDURE LocalEnv_Init;
{Fill the LocalEnv array}
VAR index : WORD;
    N, V : ANSISTRING;
BEGIN
  {$IFDEF WIN32}
  InitWin32CGI;
  {$ENDIF}
  FOR index := Low(LocalEnvStr) TO High(LocalEnvStr) DO
    BEGIN
      N := LocalEnvStr[index];
      V := UpGetEnv(N);
      IF V <> '' THEN CPAdd(LocalEnv_Chain, N, V);
    END;
  {$IFDEF WIN32}
  FInitWin32CGI;  {We don't need UpGetEnv anymore, so we call the releaser}
  {$ENDIF}
END {LocalEnv_Init};

VAR CGI_OldExitProc : POINTER;

PROCEDURE CGI_Done;
{ Free chains memory and uninstall ExitProc}
BEGIN
  ExitProc := CGI_OldExitProc;
  {$IFDEF Win32}
  FInitWin32CGI;
  {$ENDIF}
  CPDone(Cookie_Chain);
  CPDone(Query_Chain);
  CPDone(LocalEnv_Chain);
END {CGI_Done};

PROCEDURE CGI_Init;
{Initialise, get all the data from the CGI an fill Query_Array with it unescaped}
{Called at startup !}
BEGIN
  CGI_OldExitProc := ExitProc;
  ExitProc := @CGI_Done;

  CPInit(LocalEnv_Chain);
  CPInit(Query_Chain);
  CPInit(Cookie_Chain);
  LocalEnv_Init;

  QueryString := '';
  Method := UpCase(CPFind(LocalEnv_Chain, 'REQUEST_METHOD'));
  IF Method = 'POST' THEN GetData_Post
     ELSE IF Method = 'GET' THEN GetData_Get;
  IF QueryString <> '' THEN
     BEGIN
       Chop(Query_Chain, QueryString, '&');
       UnEscape(Query_Chain);
     END;

  CookieString := CPFind(LocalEnv_Chain, 'HTTP_COOKIE');
  IF CookieString <> '' THEN
     BEGIN
       Chop(Cookie_Chain, CookieString, ';');
       UnEscape(Cookie_Chain);
    END;
END {CGI_Init};

BEGIN {JoCGI}
  {$IFDEF Win32}
  IsWin32InitCGI := FALSE;
  {$ENDIF}
  CGI_Init;
END {JoCGI}.